###############################################################################
### Common part of Makefiles - should be included in all of them.
###############################################################################
.SUFFIXES: .f .o .a .exe
################### Set-up for linking the PDFLIB package #####################
# If the sell-command cernlib is defined in your system:
# 1) for shared (dynamically-linked) libraries:
#PDFS  = $(shell cernlib -dy -safe pdflib804)
# 2) for static libraries (executable files are much bigger):
#PDFS  = $(shell cernlib pdflib804)
## Otherwise set a path to CERNLIB location in your system appropriately, e.g.
#CERNLIB = /cern/cernlib
## and set linker flags for PDFLIB, e.g.
#PDFS  = -L$(CERNLIB)/lib -lpdflib804 -lmathlib -lpacklib -lkernlib
################### Set-up for linking the LHAPDF package #####################
####### It must be installed,including the LHAGLUE interface, #################
####### see  http://lhapdf.hepforge.org                       #################
PDFS = `lhapdf-config --ldflags`
#============= Collections of compiler flags for various machines =============
########### collection of IBM  flags ###########
#FFLAGS  = -qextname -O -C -qextchk 
#FFLAGS  = -qextname -g -C -qextchk -qinitauto=FF -bloadmap:lmap -qflttrap=overflow:underflow:zerodivide:invalid:enable
########### collection of HP  flags ###########
#FFLAGS  = -K -O
#FFLAGS  = -K -g -C +T
########### collection of ALPHA flags ###########
#FFLAGS  = -O2 -fpe2  -extend_source -qfixed=120 -qextname -qextchk 
#FFLAGS  = -v -g -check bounds -check overflow -check underflow -extend_source -warn argument_checking
########### collection of Linux g77 flags ###########
#FFLAGS  = -O -fno-automatic -finit-local-zero -fno-emulate-complex -ffixed-line-length-132
#FFLAGS  = -g -fno-automatic -finit-local-zero -fno-emulate-complex -ffixed-line-length-132
#F77 = g77
#FFLAGS  = -fno-automatic -finit-local-zero -fno-emulate-complex -ffixed-line-length-132
########### collection of Linux gfortran flags ###########
#FFLAGS  = -O2 -fno-automatic -finit-local-zero -fno-backslash -ffixed-line-length-132
#F77 = gfortran
############ ACTUAL flags and compiler name ###########
#FFLAGS  = -O2 -fno-automatic -ffixed-line-length-132
#F77 = gfortran
FFLAGS  = -fno-automatic -finit-local-zero -fno-emulate-complex -ffixed-line-length-132 -fno-second-underscore
F77 = g77
###### Program for building static libraries 
AR = ar
RANLIB = ranlib
###### Linker name and flags
LD = $(F77)
LDFLAGS = 
LDLIBS  = $(PDFS)
############# Pattern rules for compiling
%.o: %.f 
	$(F77) $(FFLAGS) -c $<
################################
