*##############################################################################
*# This file contains some dummy routines in order to avoid linking problems  #
*# in the case some packages/libraries are absent. If the apropriate real     #
*# routine are included these have to be removed, renamed or commented out.   #
*##############################################################################
*# Written by Wieslaw Placzek,                            Krakow, June 2006   #
*# Last update: 20.06.2006         by: WP                                     #
*##############################################################################

      SUBROUTINE EXTRAN(DrVec,Length)
*     *******************************
*/////////////////////////////////////////////////////////////////////////////
*// Dummy routine for external random number generator - to be provided     // 
*// by the user. To call it in WINHAC one should set: KeyRad = 4.           // 
*// INPUT:  Length - actual length of random number vector                  //
*// OUTPUT: DrVec  - vector of random numbers                               //
*/////////////////////////////////////////////////////////////////////////////
      IMPLICIT NONE    
      DOUBLE PRECISION DrVec(*)
      INTEGER Length
      INTEGER i
      DOUBLE PRECISION RanNum(1000)
*// Here a vector RanNum of Length random numbers should be generated

*// Please, comment out (remove) the following two lines if you provide RNG!
      WRITE(*,*) '>>> Dummy routine EXTRAN: external RNG not provided!'
      STOP       
*// Fill in vector of random numbers
      DO i = 1, Length
         DrVec(i) = RanNum(i)
      ENDDO
      END

*==============================================================================
*= Some dummy routines for the LHAPDF package, in case it is not used.        =
*= Comment/Uncomment apropriate routine names.                                =
*==============================================================================

C     SUBROUTINE InitPDFsetByName(PDFname)
      SUBROUTINE InitPDFsetByName_OFF(PDFname)
*     ****************************************
      CHARACTER*(*) PDFname
      WRITE(*,*)
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      WRITE(*,*)'>>>       Dummy routine InitPDFsetByName        <<<'
      WRITE(*,*)'>>> LHAPDF package not linked with the program  <<<'
      WRITE(*,*)'>>>  OR this dummy routine not switched OFF!    <<<'
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      STOP       
      END

C     SUBROUTINE numberPDF(Nmem)
      SUBROUTINE numberPDF_OFF(Nmem)
*     ******************************
      INTEGER Nmem
      WRITE(*,*)
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      WRITE(*,*)'>>>           Dummy routine numberPDF           <<<'
      WRITE(*,*)'>>> LHAPDF package not linked with the program  <<<'
      WRITE(*,*)'>>>  OR this dummy routine not switched OFF!    <<<'
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      STOP       
      END

C     SUBROUTINE InitPDF(Imem)
      SUBROUTINE InitPDF_OFF(Imem)
*     ****************************
      INTEGER Imem
      WRITE(*,*)
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      WRITE(*,*)'>>>            Dummy routine InitPDF            <<<'
      WRITE(*,*)'>>> LHAPDF package not linked with the program  <<<'
      WRITE(*,*)'>>>  OR this dummy routine not switched OFF!    <<<'
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      STOP       
      END

C     SUBROUTINE evolvePDF(x,Q,f)
      SUBROUTINE evolvePDF_OFF(x,Q,f)
*     *******************************
      DOUBLE PRECISION x,Q,f(-6:6)
      WRITE(*,*)
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      WRITE(*,*)'>>>           Dummy routine evolvePDF           <<<'
      WRITE(*,*)'>>> LHAPDF package not linked with the program  <<<'
      WRITE(*,*)'>>>  OR this dummy routine not switched OFF!    <<<'
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      STOP       
      END

C     SUBROUTINE evolvePDFa(x,Q,f)
      SUBROUTINE evolvePDFa_OFF(x,Q,f)
*     ********************************
      DOUBLE PRECISION x,Q,a,f(-6:6)
      WRITE(*,*)
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      WRITE(*,*)'>>>          Dummy routine evolvePDFa           <<<'
      WRITE(*,*)'>>> LHAPDF package not linked with the program  <<<'
      WRITE(*,*)'>>>  OR this dummy routine not switched OFF!    <<<'
      WRITE(*,*)'>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<'
      STOP       
      END
*==============================================================================
*= End of dummy routines for the LHAPDF package.                              =
*==============================================================================
